----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:51:53 11/02/2007 
-- Design Name: 
-- Module Name:    JK - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity JK is
   Port (
		clk_i : in  STD_LOGIC;
		ce_i 	: in  STD_LOGIC;
		rst_i : in  STD_LOGIC;
		J_i 	: in  STD_LOGIC;
		K_i 	: in  STD_LOGIC;
		Q_o 	: out STD_LOGIC
	);
end JK;

architecture Behavioral of JK is
	signal jk	: STD_LOGIC_VECTOR(1 downto 0);
	signal q		: STD_LOGIC;
begin
	
	jk <= J_i & K_i;
	
	process (clk_i)
	begin
		if clk_i'event and clk_i='1' then  
			if rst_i='1' then   
				q <= '1';
			elsif ce_i ='1' then
				case (jk) is 
					when "00" =>
						q <= q;
					when "01" =>
						q <= '0';
					when "10" =>
						q <= '1';
					when "11" =>
						q <= not q;
					when others =>
						q <= q;
				end case;
			end if;
		end if;
	end process;
	Q_o <= q;
	
end Behavioral;

