----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:36:55 11/12/2007 
-- Design Name: 
-- Module Name:    slika - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;
entity branje is
    Port ( 
			  --clk_i : in STD_LOGIC;
			  --rst_i : in STD_LOGIC;
			  --ce_i : in STD_LOGIC;
			  column_i : in  STD_LOGIC_VECTOR(9 downto 0);
			  row_i 	: in  STD_LOGIC_VECTOR(9 downto 0);
			  cr_o : out STD_LOGIC;
           adress_o : out  STD_LOGIC_VECTOR(13 downto 0)
			 );
end branje;

architecture Behavioral of branje is
COMPONENT comparator
	GENERIC(
		data_width : integer := 3
	);
	PORT(
		data1_i : IN std_logic_vector(data_width-1 downto 0);
		data2_i : IN std_logic_vector(data_width-1 downto 0);          
		equal_o : OUT std_logic
		);
	END COMPONENT;

	signal	co :	std_logic;
	signal	ro :	std_logic;
	signal adress : std_logic_vector (13 downto 0);
	
begin

	Inst_comparator_1: comparator -- column
	PORT MAP(
		data1_i => column_i(9 downto 7),
		data2_i => conv_std_logic_vector(2,3),
		equal_o => co
	);
	
	Inst_comparator_2: comparator -- row
	PORT MAP(
		data1_i => row_i(9 downto 7),
		data2_i => conv_std_logic_vector(1,3),
		equal_o => ro
	);	
	
	process (co, ro) 
	begin
		if co ='1' and ro='1' then
			adress (6 downto 0) <= column_i(6 downto 0);
			adress (13 downto 7) <= row_i(6 downto 0);
		else 
			adress <= "11111111111111";
		end if;
		
	end process;
	adress_o   <= 	adress;
	cr_o <= co and ro;

end Behavioral;