----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:31:00 11/02/2007 
-- Design Name: 
-- Module Name:    counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity counter is
	Generic	(
		data_width : integer := 8
	);
   Port	(
		ce_i 		: in  STD_LOGIC;
      clk_i 	: in  STD_LOGIC;
      rst_i 	: in  STD_LOGIC;
      we_i 		: in  STD_LOGIC;
      data_i 	: in  STD_LOGIC_VECTOR (data_width-1 downto 0);
      data_o 	: out STD_LOGIC_VECTOR (data_width-1 downto 0)
	);
end counter;

architecture Behavioral of counter is
	signal count : STD_LOGIC_VECTOR (data_width-1 downto 0);
begin

	process (clk_i) 
	begin
		if clk_i='1' and clk_i'event then
			if rst_i='1' then 
				count <= (others => '0');
			elsif ce_i='1' then
				if we_i='1' then
					count <= data_i;
				else 
					count <= count + 1;
				end if;
			end if;
		end if;
	end process; 
	data_o <= count; -- signal, ki je deklariran kot port, se ne more uporabljati kot povratna povezava 
	
end Behavioral;

