----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:04:31 01/08/2008 
-- Design Name: 
-- Module Name:    ps2pulsegen - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity ps2pulsegen is
Port (
clk_i : in STD_LOGIC;
rst_i : in STD_LOGIC;
syncclk_i : in STD_LOGIC;
pulse_o : out STD_LOGIC
);
end ps2pulsegen;
architecture Behavioral of ps2pulsegen is
--Use descriptive names for the states :
type state_type is ( st1_IDLE , st2_PULSE , st3_WAIT);
signal state , next_state : state_type;
-- Declare internal signals for all outputs of the state machine
signal pulse : std_logic;
begin
SYNC_PROC: process ( clk_i )
begin
if (clk_i ' event and clk_i = '1') then
if ( rst_i = '1') then
state <= st1_IDLE;
pulse_o <= '0';
else
state <= next_state;
pulse_o <= pulse ;
end if;
end if;
end process;
--MEALY State Machine - Outputs based on state and inputs
OUTPUT_DECODE: process ( state , syncclk_i)
begin
--decode internal output signals
case ( state ) is
when st1_IDLE =>
if syncclk_i = '0' then
pulse <= '1';
else
pulse <= '0';
end if;
when st2_PULSE =>
pulse <= '0';
when st3_WAIT =>
pulse <= '0';
when others =>
pulse <= '0';
end case;
end process;
NEXT_STATE_DECODE: process (state , syncclk_i)
begin
-- declare default state for next_state to avoid latches
next_state <= state; --default is to stay in current state
--decode next_state:
case ( state ) is
when st1_IDLE =>
if syncclk_i = '0' then
next_state <= st2_PULSE;
end if;
when st2_PULSE =>
next_state <= st3_WAIT;
when st3_WAIT =>
if syncclk_i = '1' then
next_state <= st1_IDLE;
end if;
when others =>
next_state <= st1_IDLE;
end case;
end process;
end Behavioral;