----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:40:37 11/05/2007 
-- Design Name: 
-- Module Name:    vga_krmilnik - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity vga_krmilnik is
   Port	(
		clk_i 	: in  STD_LOGIC;
		rst_i 	: in  STD_LOGIC;
		red_i 	: in  STD_LOGIC;
		green_i 	: in  STD_LOGIC;
		blue_i 	: in  STD_LOGIC;
		hsync_o 	: out  STD_LOGIC;
		vsync_o 	: out  STD_LOGIC;
		red_o 	: out  STD_LOGIC;
		green_o 	: out  STD_LOGIC;
		blue_o 	: out  STD_LOGIC;
		column_o : out  STD_LOGIC_VECTOR (9 downto 0);
		row_o 	: out  STD_LOGIC_VECTOR (9 downto 0)
	);
end vga_krmilnik;

architecture Behavioral of vga_krmilnik is
	COMPONENT hsync
	PORT(
		clk_i 		: IN std_logic;
		rst_i 		: IN std_logic;
		ce_i 			: IN std_logic;          
		Hsync_o 		: OUT std_logic;
		HDataOn_o 	: OUT std_logic;
		rowclk_o 	: OUT std_logic;
		column_o 	: OUT std_logic_vector(9 downto 0)
	);
	END COMPONENT;
	
	
	COMPONENT vsync
	PORT(
		clk_i : IN std_logic;
		rst_i : IN std_logic;
		--ce_i : IN std_logic;
		rowclk_i : IN std_logic;          
		Vsync_o : OUT std_logic;
		VDataOn_o : OUT std_logic;
		row_o : OUT std_logic_vector(9 downto 0)
		);
	END COMPONENT;

	signal Hsync_s	: std_logic;
	signal HDataOn	: std_logic;
	signal row_clk	: std_logic;
	signal column	: std_logic_vector(9 downto 0);
	signal Vsync_s	: std_logic;
	signal VDataOn	: std_logic;
	signal row		: std_logic_vector(9 downto 0);
	--signal red		: std_logic;
	--signal green	: std_logic;
	--signal blue		: std_logic;
	
begin
	-- IO Assignemnts:
	hsync_o 		<=	Hsync_s;
	vsync_o		<=	Vsync_s;
	column_o		<= column;
	row_o			<= row;
	
	red_o			<= red_i;
	green_o		<= green_i;
	blue_o		<= blue_i;
	
	-- Gates:
	
	-- Components instantiation:
	Inst_hsync: hsync
	PORT MAP(
		clk_i => clk_i,
		rst_i => rst_i,
		ce_i => '1',
		Hsync_o => Hsync_s,
		HDataOn_o => HDataOn,
		rowclk_o => row_clk,
		column_o => column
	);

	Inst_vsync: vsync
	PORT MAP(
		clk_i => clk_i,
		rst_i => rst_i,
		rowclk_i => row_clk, --kao ce_i za ta ip
		Vsync_o => Vsync_s,
		VDataOn_o => VDataOn,
		row_o => row
	);
end Behavioral;

