----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:36:06 11/12/2007 
-- Design Name: 
-- Module Name:    vga_top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity vga_top is
    Port ( clk_i : in  STD_LOGIC;
           rst_i : in  STD_LOGIC;
			  we_i : in STD_LOGIC;
			  adress_w_i : in STD_LOGIC_VECTOR(13 downto 0);
			  data_i : in STD_LOGIC_VECTOR(2 downto 0);
           hsync_o : out  STD_LOGIC;
           vsync_o : out  STD_LOGIC;
           r_o : out  STD_LOGIC;
           g_o : out  STD_LOGIC;
           b_o : out  STD_LOGIC);
end vga_top;

architecture Behavioral of vga_top is
	COMPONENT vga_krmilnik
	PORT(
		clk_i : IN std_logic;
		rst_i : IN std_logic;
		red_i : IN std_logic;
		green_i : IN std_logic;
		blue_i : IN std_logic;          
		hsync_o : OUT std_logic;
		vsync_o : OUT std_logic;
		red_o : OUT std_logic;
		green_o : OUT std_logic;
		blue_o : OUT std_logic;
		column_o : OUT std_logic_vector(9 downto 0);
		row_o : OUT std_logic_vector(9 downto 0)
		);
	END COMPONENT;
	
	COMPONENT ram
	PORT(
		clk_i : IN std_logic;
		we_i : IN std_logic;
		adress_i : IN std_logic_vector(13 downto 0);
		adress_w_i : IN std_logic_vector(13 downto 0);
		data_w_i : IN std_logic_vector(2 downto 0);          
		data_1_o : OUT std_logic_vector(2 downto 0)
		--data_2_o : OUT std_logic_vector(2 downto 0)
		);
	END COMPONENT;
	
	COMPONENT branje
	PORT(
	--	clk_i : IN std_logic;
	--	rst_i : IN std_logic;
	--	ce_i : IN std_logic;
		column_i : IN std_logic_vector(9 downto 0);
		row_i : IN std_logic_vector(9 downto 0); 
		cr_o : OUT std_logic;
		adress_o : OUT std_logic_vector(13 downto 0)
		);
	END COMPONENT;
	
	COMPONENT syn
	PORT(
		clk_i : in  STD_LOGIC;
      rst_i : in  STD_LOGIC;
		r_i : IN std_logic;
		g_i : IN std_logic;
		b_i : IN std_logic;
		cr_i : IN std_logic;          
		r_o : OUT std_logic;
		g_o : OUT std_logic;
		b_o : OUT std_logic
		);
	END COMPONENT;
	
		COMPONENT dc
	PORT(
		clk_i : IN std_logic;
		rst_i : IN std_logic;
		cr_i : IN std_logic;          
		cr_o : OUT std_logic
		);
	END COMPONENT;
	
	--COMPONENT test
	--PORT(          
	--	adress_o : OUT std_logic_vector(13 downto 0);
	--	data_o : OUT std_logic_vector(2 downto 0)
	--	);
	--END COMPONENT;
	
	signal	r:	std_logic;
	signal	g:	std_logic;
	signal	b:	std_logic;
	signal	tr:	std_logic;
	signal	tg:	std_logic;
	signal	tb:	std_logic;
	signal	column:	std_logic_vector(9 downto 0);
	signal	row:	std_logic_vector(9 downto 0);
	--signal data : std_logic_vector (2 downto 0);
	signal adress : std_logic_vector (13 downto 0);
	--signal adress_w : std_logic_vector (13 downto 0); 
	--signal datargb : std_logic_vector (2 downto 0);   
	signal	cr1:	std_logic;
	signal	cr2:	std_logic;
begin

	Inst_vga_krmilnik: vga_krmilnik
	PORT MAP(
		clk_i => clk_i,
		rst_i => rst_i,
		red_i => r,
		green_i => g,
		blue_i => b,
		hsync_o => hsync_o,
		vsync_o => vsync_o,
		red_o => tr,
		green_o => tg,
		blue_o => tb,
		column_o => column,
		row_o => row
	);

		Inst_ram: ram PORT MAP(
		clk_i => clk_i,
		we_i => we_i,
		adress_i =>  adress,
		adress_w_i => adress_w_i,
		data_w_i => data_i,
		data_1_o(2) => r,
		data_1_o(1) => g,
		data_1_o(0) => b
		--data_2_o => 
	);
	
		Inst_branje: branje 
		PORT MAP(
		--clk_i => clk_i,
		--rst_i => rst_i,
		--ce_i => ce_i,
		column_i => column,
		row_i => row,
		cr_o => cr1,
		adress_o => adress
	);
	
		Inst_syn: syn 
		PORT MAP(
		clk_i => clk_i,
		rst_i => rst_i,
		r_i => tr,
		g_i => tg,
		b_i => tb,
		cr_i => cr2,
		r_o => r_o,
		g_o => g_o,
		b_o => b_o 
	);
	
		Inst_dc: dc PORT MAP(
		clk_i => clk_i,
		rst_i => rst_i,
		cr_i => cr1,
		cr_o => cr2
	);

	
--		Inst_test: test PORT MAP(
--		adress_o => adress_w ,
--		data_o => datargb
--	);
end Behavioral;
